//libraries
#include <NewPing.h>
#include <NewTone.h>

//important pins
#define TONE_PIN 6 //Connected to piezo speaker
#define TRIGGER_PIN  A2  // Arduino pin tied to trigger pin on the ultrasonic sensor.
#define ECHO_PIN     A3  // Arduino pin tied to echo pin on the ultrasonic sensor.
#define MAX_DISTANCE 200 // Maximum distance we want to ping for (in centimeters). Maximum sensor distance is rated at 400-500cm.
#define happylight A1 //green LED
#define sadlight A0 //red LED
#define button 5 //momentary switch input



//setup sonar
NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE); // NewPing setup of pins and maximum distance.



void setup() {
   //Setup Channel A
  pinMode(12, OUTPUT); //Initiates Motor Channel A pin
  pinMode(9, OUTPUT); //Initiates Brake Channel A pin
  //Setup Channel B
  pinMode(13, OUTPUT); //Initiates Motor Channel A pin
  pinMode(8, OUTPUT);  //Initiates Brake Channel A pin
  //setup LED
  pinMode(A0,OUTPUT);
  pinMode(A1,OUTPUT);
  //setup button
  pinMode(5,INPUT);
  Serial.begin(9600); //Serial communication

  //startup sound
    for (unsigned long freq = 125; freq <= 15000; freq += 10) {  
    NewTone(TONE_PIN, freq); // Play the frequency (125 Hz to 15 kHz sweep in 10 Hz steps).
    delay(1); // Wait 1 ms so you can hear it.
  }
  noNewTone(TONE_PIN); // Turn off the tone.

  delay(1000); // Wait a second.

}

void loop(){
    driveForwards();
    happy();
    checkObstacle();
    };


void driveForwards(){
   //Motor A forward @ slow
  digitalWrite(12, HIGH); //Establishes forward direction of Channel A
  digitalWrite(9, LOW);   //Disengage the Brake for Channel A
  analogWrite(3, 75);   //Spins the motor on Channel A at full speed

  //Motor B forward @ slow
  digitalWrite(13, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 75);    //Spins the motor on Channel B at half speed

    }

void stop(){
    digitalWrite(8,HIGH);
    digitalWrite(9,HIGH);
    sad();
  }

void checkObstacle(){
  int distance = sonar.ping_cm();
  if (distance > 0 && distance < 10){
      stop();
      Serial.println("Obstacle Detected");
      retreat();
      delay(500);

      while(distance < 20){
      distance = sonar.ping_cm();
      //Motor A forward @ half speed
      digitalWrite(12, HIGH); 
      digitalWrite(9, LOW);  
      analogWrite(3, 50);  
    
      //Motor B forward @ full speed
      digitalWrite(13, LOW);  //Establishes forward direction of Channel B
      digitalWrite(8, LOW);   //Disengage the Brake for Channel B
      analogWrite(11, 50);    //Spins the motor on Channel B at half speed

      //printdistance
      Serial.println(distance);
      delay(100);
      }
      Serial.println("good to go");
    }

   }



    void retreat(){
  
  //Motor A backward
  digitalWrite(12, LOW); //Establishes forward direction of Channel A
  digitalWrite(9, LOW);   //Disengage the Brake for Channel A
  analogWrite(3, 100);   //Spins the motor on Channel A at full speed

  //Motor B backward
  digitalWrite(13, LOW);  //Establishes forward direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 100);    //Spins the motor on Channel B at half speed
    }

 void swivelLeft(){
  //Motor A forward @ half speed
      digitalWrite(12, HIGH); 
      digitalWrite(9, LOW);  
      analogWrite(3, 50);  
    
      //Motor B forward @ full speed
      digitalWrite(13, LOW);  //Establishes forward direction of Channel B
      digitalWrite(8, LOW);   //Disengage the Brake for Channel B
      analogWrite(11, 50);    //Spins the motor on Channel B at half speed

     }

void happy(){
  analogWrite(happylight,1000);
  analogWrite(sadlight,0);
   
  }

  void sad(){
  analogWrite(happylight,0);
  analogWrite(sadlight,1000);
   
  }
    
